/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * File Name          : freertos.c
  * Description        : Code for freertos applications
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "main.h"
#include "cmsis_os.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include "key.h"
#include "usart.h"
void Jump_interface(Menu_table menu);
extern Menu_table menu;
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN Variables */
/* USER CODE END Variables */
osThreadId ScanKeyTaskHandle;
osThreadId BT4GTaskHandle;
osThreadId testTaskHandle;
osThreadId loginfoTaskHandle;

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN FunctionPrototypes */


/* USER CODE END FunctionPrototypes */

void StartScanKeyTask(void const * argument);
void StarBT4GTask(void const * argument);
void StartTestTask(void const * argument);
void StartloginfoTaskTask(void const * argument);

void MX_FREERTOS_Init(void); /* (MISRA C 2004 rule 8.1) */

/* GetIdleTaskMemory prototype (linked to static allocation support) */
void vApplicationGetIdleTaskMemory( StaticTask_t **ppxIdleTaskTCBBuffer, StackType_t **ppxIdleTaskStackBuffer, uint32_t *pulIdleTaskStackSize );

/* USER CODE BEGIN GET_IDLE_TASK_MEMORY */
static StaticTask_t xIdleTaskTCBBuffer;
static StackType_t xIdleStack[configMINIMAL_STACK_SIZE];

void vApplicationGetIdleTaskMemory( StaticTask_t **ppxIdleTaskTCBBuffer, StackType_t **ppxIdleTaskStackBuffer, uint32_t *pulIdleTaskStackSize )
{
  *ppxIdleTaskTCBBuffer = &xIdleTaskTCBBuffer;
  *ppxIdleTaskStackBuffer = &xIdleStack[0];
  *pulIdleTaskStackSize = configMINIMAL_STACK_SIZE;
  /* place for user code */
}
/* USER CODE END GET_IDLE_TASK_MEMORY */

/**
  * @brief  FreeRTOS initialization
  * @param  None
  * @retval None
  */
void MX_FREERTOS_Init(void) {
  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
  /* USER CODE END RTOS_QUEUES */

  /* Create the thread(s) */
  /* definition and creation of ScanKeyTask */
  osThreadDef(ScanKeyTask, StartScanKeyTask, osPriorityRealtime, 0, 128);
  ScanKeyTaskHandle = osThreadCreate(osThread(ScanKeyTask), NULL);

  /* definition and creation of BT4GTask */
  osThreadDef(BT4GTask, StarBT4GTask, osPriorityRealtime, 0, 128);
  BT4GTaskHandle = osThreadCreate(osThread(BT4GTask), NULL);

  /* definition and creation of testTask */
  osThreadDef(testTask, StartTestTask, osPriorityRealtime, 0, 128);
  testTaskHandle = osThreadCreate(osThread(testTask), NULL);

  /* definition and creation of loginfoTask */
  osThreadDef(loginfoTask, StartloginfoTaskTask, osPriorityRealtime, 0, 128);
  loginfoTaskHandle = osThreadCreate(osThread(loginfoTask), NULL);

  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */
  /* USER CODE END RTOS_THREADS */

}

/* USER CODE BEGIN Header_StartScanKeyTask */
/**
  * @brief  Function implementing the ScanKeyTask thread.
  * @param  argument: Not used
  * @retval None
  */
/* USER CODE END Header_StartScanKeyTask */
void StartScanKeyTask(void const * argument)
{
  /* USER CODE BEGIN StartScanKeyTask */
  /* Infinite loop */
  for(;;)
  {
    osDelay(1);
	updatekeystate(); 
    Jump_interface(menu); 
    OLED_Refresh(); 
	open_close_lock();
	workinfo_W();
  }
  /* USER CODE END StartScanKeyTask */
}

/* USER CODE BEGIN Header_StarBT4GTask */
/**
* @brief Function implementing the BT4GTask thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StarBT4GTask */
void StarBT4GTask(void const * argument)
{
  /* USER CODE BEGIN StarBT4GTask */

  /* Infinite loop */
  for(;;)
  {
    osDelay(1);
	  
	  
	  
	  
  }
  /* USER CODE END StarBT4GTask */
}

/* USER CODE BEGIN Header_StartTestTask */
/**
* @brief Function implementing the testTask thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartTestTask */
void StartTestTask(void const * argument)
{
  /* USER CODE BEGIN StartTestTask */

  /* Infinite loop */
  for(;;)
  {
    osDelay(1);
	  if(S1==0x1111)
	  {
		  menu.home=0x1000;
	  }
	  if(S1==0x2222)
	  {
		  menu.home=0xF000;
	  }
	  if(S2==0x1111)
	  {
		  menu.home |= 0x0100;
	  }
	  if(S2==0x2222)
	  {
		  menu.home |= 0x0F00;
	  }
  }
  /* USER CODE END StartTestTask */
}

/* USER CODE BEGIN Header_StartloginfoTaskTask */
/**
* @brief Function implementing the loginfoTask thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartloginfoTaskTask */
void StartloginfoTaskTask(void const * argument)
{
  /* USER CODE BEGIN StartloginfoTaskTask */
  /* Infinite loop */
  for(;;)
  {
    osDelay(1000);
	//dtu_test();

		//lock_searchInfo();

  }
  /* USER CODE END StartloginfoTaskTask */
}

/* Private application code --------------------------------------------------*/
/* USER CODE BEGIN Application */

/* USER CODE END Application */

